website/main/urls.py
from django.conf.urls import include, url
from django.contrib import admin

from django.contrib.staticfiles.urls import staticfiles_urlpatterns

from django.conf import settings
from django.conf.urls.static import static

#for favicon URL
from django.contrib.staticfiles.storage import staticfiles_storage
from django.views.generic.base import RedirectView

urlpatterns = [
    url(r'^admin/', admin.site.urls),
    url('', include('searching.urls')),
    url('', include('users.urls')),
    url(r'^accounts/', include('shops.urls')), #shops are available only under account
    url(r'^accounts/', include('shopsortiment.urls')), #shops sortiment is available only under account
    url(r'^accounts/', include('sortiment.urls')), #sortiment is available only under account
    url(r'^accounts/', include('categories.urls')), #categories are available only under account
    #url(r'^search/', include('haystack.urls')),
    url(
        r'^favicon.ico$',
        RedirectView.as_view(
            url=staticfiles_storage.url('favicon.ico'),
            permanent=False),
        name="favicon"
    ),
]

urlpatterns += staticfiles_urlpatterns()

if settings.DEBUG:
    urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

website/shopsortiment/urls.py
from django.urls import path
from django.contrib.auth.decorators import login_required

# include views for rendering the output
from .views import edShopSortimentListView
from .views import edShopSortimentCreateView
from .views import edShopSortimentUpdateView
from .views import edShopSortimentDeleteView

app_name = 'shopsortiment'

urlpatterns = [
    path('shopsortiment/', login_required(edShopSortimentListView.as_view()), name='view'),
    path('shopsortiment/new/', login_required(edShopSortimentCreateView.as_view()), name='new'),
    path('shopsortiment/<int:pk>', login_required(edShopSortimentUpdateView.as_view()), name='edit'),
    path('shopsortiment/<int:pk>/delete/', login_required(edShopSortimentDeleteView.as_view()), name='delete'),
]

website/shopsortiment/models.py
from django.db import models
from django.utils.safestring import mark_safe
from django.conf import settings
# for image resizing use imagekit
from imagekit.models import ImageSpecField
from imagekit.processors import ResizeToFill, Adjust

from sortiment.models import edSortiment
from shops.models import edShop
from users.models import User

# ===================== Models ===================== #
# shops sortiment with 
class edShopSortiment(models.Model):
    price_vat = models.FloatField("Price including VAT", null=True, blank=True, default=None)
    price_no_vat = models.FloatField("Price excluding VAT", null=True, blank=True, default=None)
    status = models.CharField("Status", max_length=50, null=True, blank=True, default=None)
    additional_info = models.CharField("Additional information", max_length=500, null=True, blank=True, default=None)
    # 
    added_date = models.DateTimeField("Date added", auto_now_add=True, null=True)
    modified_date = models.DateTimeField("Last modified date", auto_now=True, null=True)
    owner = models.ForeignKey(
        User,
        on_delete=models.CASCADE,
        default=1,
    )
    shops = models.ManyToManyField(edShop)
    sortiment = models.ForeignKey(
        edSortiment,
        on_delete=models.CASCADE,
        blank=True,
        null=True,
    )
    
    def __str__(self):
        return self.sortiment.name

website/shopsortiment/views.py
from django.shortcuts import render
from django.views import generic
from django.views.generic.edit import FormView, CreateView, UpdateView, DeleteView
from django.urls import reverse_lazy

# include main model for shops
from .models import edShopSortiment

#####   Sortiment Views
class edShopSortimentListView(generic.ListView):
    model = edShopSortiment
    context_object_name = 'shopsortiment'   # your own name for the list as a template variable
    template_name = 'shopsortiment/list.html'  # Specify your own template name/location

class edShopSortimentDetailView(generic.DetailView):
    model = edShopSortiment   
    context_object_name = 'shopsortiment'   # your own name for the list as a template variable
    template_name = 'shopsortiment/detail.html'  # Specify your own template name/location 

class edShopSortimentCreateView(CreateView):
    model = edShopSortiment
    context_object_name = 'shopsortiment'   # your own name for the list as a template variable
    template_name = 'shopsortiment/new.html'
    fields = ['sortiment','shops','price_vat', 'price_no_vat', 'status', 'additional_info']
    success_url = reverse_lazy('shopsortiment:view')
    def form_valid(self, form):
        form.instance.owner = self.request.user
        return super(edShopSortimentCreateView, self).form_valid(form)

class edShopSortimentUpdateView(UpdateView):
    model = edShopSortiment
    template_name = 'shopsortiment/edit.html'
    context_object_name = 'shopsortiment'   # your own name for the list as a template variable
    fields = ['sortiment','shops','price_vat', 'price_no_vat', 'status', 'additional_info']
    success_url = reverse_lazy('shopsortiment:view')

class edShopSortimentDeleteView(DeleteView):
    model = edShopSortiment
    #template_name = 'stores/edSortiment_confirm_delete.html'
    success_url = reverse_lazy('shopsortiment:view')

website/templates/shopsortiment/edit.html
{% extends 'main/base_editform.html' %}

{% block content %}

<div class="page-header header-filter" data-parallax="true" style="background-image: url('{{ landing_top }}'); background-size: cover; background-position: top center;">
    <div class="container">
        <div class="row">
            <div class="col-md-6 ml-auto mr-auto">

            <!-- Edit form -->
            <form class="form" method="POST" enctype="multipart/form-data" action="{% url 'shopsortiment:edit' shopsortiment.id %}">
                {% csrf_token %}
                <div class="card card-signup">
                    <h2 class="card-title text-center">{{ shopsortiment.sortiment.name }}</h2>
                    <div class="card-body">
                        <div class="row">
                            <div class="col-lg-10 col-md-12 col-sm-12 ml-auto mr-auto">
                                {% for hidden_field in form.hidden_fields %}
                                    {{ hidden_field }}
                                {% endfor %}

                                {% if form.non_field_errors %}
                                <div class="alert alert-danger" role="alert">
                                    {% for error in form.non_field_errors %}
                                    {{ error }}
                                    {% endfor %}
                                </div>
                                {% endif %}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-10 col-md-12 col-sm-12 ml-auto mr-auto">
                                {% for field in form.visible_fields %}
                                    {% if field.field.widget.input_type != "file" %}
                                        {% include "main/form_field.html" with field=field %}
                                    {% endif %}
                                {% endfor %}
                            </div>
                        </div>
                        <div class="row">
                            <div class="col-lg-10 col-md-10 col-sm-12 ml-auto mr-auto">
                                <div class="card-footer justify-content-center">
                                    <button type="submit" class="btn btn-success btn-round">Saglabāt</button>
                                    <a href="{% url 'shopsortiment:view' %}" class="btn btn-default btn-round ml-3">Atcelt</a>
                                </div>
                                <input type="hidden" name="next" value="{{ next }}" />        
                            </div>
                        </div>

                    </div>
                    
                </div>
            </form>

{% if next %}
  {% if user.is_authenticated %}
    <p>Your account doesn't have access to this page. To proceed,
    please login with an account that has access.</p>
  {% else %}
    <p>Please login to see this page.</p>
  {% endif %}
{% endif %}
                
                </div>
        </div>
    </div>
</div>
  

{% endblock %}

website/templates/shopsortiment/form_field.html
{% load widget_tweaks %}
<div class="form-group bmd-form-group">
        {% if field.field.widget.input_type != "file" %}
        {{ field.label_tag }}
        {% endif %}

        {% if form.is_bound %}
            {% if field.errors %}
                {% render_field field class="form-control is-invalid" %}
                {% for error in field.errors %}
                <div class="invalid-feedback">
                    {{ error }}
                </div>
                {% endfor %}
            {% else %}
                {% render_field field class="form-control is-valid" %}
            {% endif %}
        {% else %}
            {% if field.field.widget.input_type == "select" %}
                {% render_field field class="selectpicker col-md-12 px-0" data-style="select-with-transition" %}
            {% elif field.field.widget.input_type == "file" %}
                <div class="fileinput fileinput-{% if form.instance.photo.name == 'products/default.jpg' %}new{% else %}exists{% endif %} text-center" data-provides="fileinput">
                    <div class="fileinput-{% if form.instance.photo.name == 'products/default.jpg' %}new{% else %}exists{% endif %} thumbnail img-raised">
                        <img src="{{ form.instance.photo.url }}" alt="...">
                    </div>
                    <div class="fileinput-preview fileinput-{% if form.instance.photo.name == 'products/default.jpg' %}new{% else %}exists{% endif %} thumbnail img-raised"></div>
                    <div>
                        <span class="btn btn-raised btn-round btn-default btn-file">
                            <span class="fileinput-new">Select image</span>
                            <span class="fileinput-exists">Change</span>
                            <input type="file" name="..." id="{{form.photo.auto_id}}">
                        </span>
                        <a href="#pablo" class="btn btn-danger btn-round fileinput-exists" data-dismiss="fileinput">
                        <i class="fa fa-times"></i> Remove</a>
                    </div>
                </div>
            {% else %}
                {% render_field field class="form-control" %}
            {% endif %}
        {% endif %}

        {% if field.help_text %}
            <small class="form-text text-muted">{{ field.help_text }}</small>
        {% endif %}
    </div>

website/templates/shopsortiment/list.html
{% extends 'main/base.html' %}

{% block content %}
  
    <div class="container">
        <div class="row">
            <div class="col-lg-8 col-md-10 ml-auto mr-auto">

                <div class="section">
                        <div class="container">
                            <h2 class="section-title">Sortiments</h2>

                            <div class="row">
                                {% if shopsortiment %}
                                <div class="table-responsive">
                                <table class="table table-shopping">
                                    <thead>
                                    <tr>
                                        <th>Nosaukums</th>
                                        <th>Veikali</th>
                                        <th>Tilpums</th>
                                        <th>Cena</th>
                                        <th class="text-right"></th>
                                    </tr>
                                    </thead>
                                    <tbody>
                                    {% for shopsortiment in shopsortiment %}
                                    <tr>
                                        <td><img src="{{shopsortiment.sortiment.photo_thumbnail_mini.url}}"> {{ shopsortiment.sortiment.name|default_if_none:"" }} ({{shopsortiment.sortiment.EAN|default_if_none:""}})</td>
                                        <td>{% for shop in shopsortiment.shops.all %}
                                                {{shop.code|default_if_none:""}}: {{shop.name|default_if_none:""}} ({{shop.city|default_if_none:""}}, {{shop.street|default_if_none:""}} {{shop.number|default_if_none:""}}, {{shop.postal_code|default_if_none:""}})
                                                <br>
                                            {% endfor %}
                                        </td>
                                        <td>{{shopsortiment.sortiment.liters|default_if_none:""}}l</td>
                                        <td>{{shopsortiment.price_vat|default_if_none:""}} €</td>
                                        <td class="td-actions text-right">
                                            <form method="POST" action="{% url 'shopsortiment:delete' shopsortiment.id %}">
                                                {% csrf_token %}
                                                <a href="{% url 'shopsortiment:edit' shopsortiment.id %}">
                                                    <button type="button" rel="tooltip" class="btn btn-success btn-round btn-just-icon btn-sm" data-original-title="" title="">
                                                        <i class="material-icons">edit</i>
                                                    </button>
                                                </a>
                                                <a href="{% url 'shopsortiment:delete' shopsortiment.id %}">
                                                <button type="submit" rel="tooltip" class="btn btn-danger btn-round btn-just-icon btn-sm" data-original-title="" title="" onClick="return confirm('Vai tiešām vēlaties dzēst?');">
                                                    <i class="material-icons">close</i>
                                                </button>
                                                </a>
                                            </form>
                                        </td>
                                    </tr>
                                    {% endfor %}
                                    </tbody>
                                </table>
                                <p>
                                    <a href="{% url 'shopsortiment:new' %}" class="btn btn-success btn-round btn-just-icon btn-md">
                                        <i class="material-icons">add</i>
                                    </a>
                                </p>
                                </div>
                                {% else %}
                                <p> 
                                    <a href="{% url 'shopsortiment:new' %}" class="btn btn-success btn-round btn-just-icon btn-md">
                                        <i class="material-icons">add</i>
                                    </a>
                                    Sortiments ir tukšs. Pievienot jaunu preces vienību.
                                </p>
                                {% endif %}  
                            </div>
                    
                        </div>
                    </div>    
            
                </div>
        </div>
    </div>

  

{% endblock %}

website/templates/shopsortiment/new.html
{% extends 'main/base_editform.html' %}

{% block content %}

<div class="page-header header-filter" data-parallax="true" style="background-image: url('{{ landing_top }}'); background-size: cover; background-position: top center;">
    <div class="container">
        <div class="row">
            <div class="col-md-6 ml-auto mr-auto">

                <!-- Edit form -->
    <form class="form" method="POST" enctype="multipart/form-data" action="{% url 'shopsortiment:new' %}">
        {% csrf_token %}
        <div class="card card-signup">
            <h2 class="card-title text-center">Pievienot preces vienību</h2>
            <div class="card-body">
                <div class="row">
                    <div class="col-md-12 ml-auto mr-auto">
                        {% for hidden_field in form.hidden_fields %}
                            {{ hidden_field }}
                        {% endfor %}

                        {% if form.non_field_errors %}
                        <div class="alert alert-danger" role="alert">
                            {% for error in form.non_field_errors %}
                            {{ error }}
                            {% endfor %}
                        </div>
                        {% endif %}
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-4 ml-auto mr-auto">
                        {% for field in form.visible_fields %}
                            {% if field.field.widget.input_type == "file" %}
                                {% include "main/form_field.html" with field=field %}
                            {% endif %}
                        {% endfor %}
                    </div>
                    <div class="col-md-6 ml-auto mr-auto">
                        {% for field in form.visible_fields %}
                            {% if field.field.widget.input_type != "file" %}
                                {% include "main/form_field.html" with field=field %}
                            {% endif %}
                        {% endfor %}
                    </div>
                </div>
                <div class="row">
                    <div class="col-md-10 ml-auto mr-auto">
                        <div class="card-footer justify-content-center">
                            <button type="submit" class="btn btn-success btn-round">Saglabāt</button>
                            <a href="{% url 'shopsortiment:view' %}" class="btn btn-default btn-round ml-3">Atcelt</a>
                        </div>
                        <input type="hidden" name="next" value="{{ next }}" />        
                    </div>
                </div>

            </div>
            
        </div>
            </form>

{% if next %}
  {% if user.is_authenticated %}
    <p>Your account doesn't have access to this page. To proceed,
    please login with an account that has access.</p>
  {% else %}
    <p>Please login to see this page.</p>
  {% endif %}
{% endif %}
                
                </div>
        </div>
    </div>
</div>
  

{% endblock %}